#ifndef _TCP_SOCKET_H_
#define _TCP_SOCKET_H_

#include <stdio.h>
#include <sys/types.h>
#include <netinet/in.h>

typedef struct
{
	int	s;			/* the low level socket */
	FILE	*in;			/* input stream */
	FILE	*out;			/* output stream */
	int	is_open;		/* the socket is open */
	int	is_connected;		/* have a connection */
	int	have_stream;		/* stream has been fdopen()ed */

	struct sockaddr_in local;	/* local address */
	struct sockaddr_in remote;	/* remote address */
} TCPSocket;


TCPSocket *new_TCPSocket(char *host, int port);
TCPSocket *TCPSocket_alloc(void);
void TCPSocket_free(TCPSocket *sock);

int TCPSocket_init(TCPSocket *sock);
int TCPSocket_connect(TCPSocket *sock, char *host, int port);
int TCPSocket_createStream(TCPSocket *sock);

FILE *TCPSocket_getInputStream(TCPSocket *sock);
FILE *TCPSocket_getOutputStream(TCPSocket *sock);
 
int TCPSocket_getSocket(TCPSocket *sock);

#endif /* _TCP_SOCKET_H_ */

